package com.example.arqdemo;

import javax.enterprise.inject.Produces;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

/*
 * Once Arquillian supports the deployment of @DataSourceDefinition we should
 * be able to create an application-scoped datasource for testing.
 * 
 * As of Arquillian 1.0.0 on JBoss AS 7.1.1.Final, uncommenting the following
 * has no effect; it's ignored.
 */
/*
@javax.ejb.Stateless
@javax.annotation.sql.DataSourceDefinition(
    name = "java:app/jdbc/myDS",    
    className = "org.h2.Driver",
    url="jdbc:h2:mem:"
)
*/
public class Database {
  
    /*
     * This is a CDI producer field; it makes instances of the entity manager
     * for the persistence unit injectable throughout the application using
     * 
     *     @Inject EntityManager em;
     * 
     * without the need to specify a persistence unit name. We centralise the
     * persistence unit name specification to here so we can easily swap it
     * out using @Alternative beans.
     * 
     */
    @Produces
    @PersistenceContext(unitName="myPU")
    protected static EntityManager em;
    
}