package com.example.arqdemo;

import javax.ejb.Stateless;
import javax.inject.Inject;
import javax.persistence.EntityManager;
import org.apache.commons.lang3.RandomStringUtils;

@Stateless
public class Demo {
    
    @Inject
    private EntityManager em;
    
    public boolean entityManagerIsInjected() {
        return em != null;
    }
    
    public String getGarbage(Integer id) {        
        SimpleEntity e = em.find(SimpleEntity.class, id);
        return e == null ? null : e.getGarbage();
    }
    
    public void setGarbage(Integer id, String garbage) {
        SimpleEntity e = createIfNotFound(id);
        e.setGarbage(garbage);
        em.merge(e);
    }
    
    public void setGarbageToRandom(Integer id) {
        // Use Commons Lang 3's RandomStringUtils to set the entity's contents
        // to some random garbage. This just proves we've successfully added
        // commons lang 3 to our test archive.
        setGarbage(id, RandomStringUtils.random(20));
    }
    
    private SimpleEntity createIfNotFound(Integer id) {
        SimpleEntity e = em.find(SimpleEntity.class, id);
        if (e == null) {
            e = new SimpleEntity();
            e.setId(id);
        }
        return e;
    }
}
